<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import HeaderLogo from './header-logo.vue';
import VideoModal from '~/components/solutions/video-modal.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

interface HeroImage {
  src: string;
  alt?: string;
}

interface HeroVideo {
  video_url: string;
  is_video_thumbnail: string;
}

interface HeroButton {
  text: string;
  href: string;
  variant?: string;
  icon?: {
    name: string;
    variant: string;
    size?: string;
  };
  dataGaName?: string;
  dataGaLocation?: string;
}

interface Banner {
  text: string;
  href: string;
  show: boolean;
}

interface Pill {
  text: string;
  anchor: string;
}

export default Vue.extend({
  components: {
    HeaderLogo,
    VideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    header: {
      type: String,
      required: false,
      default: '',
    },
    description: {
      type: String,
      required: false,
      default: '',
    },
    image: {
      type: Object as PropType<HeroImage>,
      required: false,
      default: null,
    },
    video: {
      type: Object as PropType<HeroVideo>,
      required: false,
      default: null,
    },
    button: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
    secondaryButton: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
    banner: {
      type: Object as PropType<Banner>,
      required: false,
      default: null,
    },
    pill: {
      type: Object as PropType<Pill>,
      required: false,
      default: null,
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <div class="hero-wrapper">
        <div class="hero-text">
          <div v-if="pill" class="hero-pill slp-mb-24 animated">
            <a
              :href="pill.anchor"
              :data-ga-name="pill.data_ga_name"
              :data-ga-location="pill.data_ga_location"
            >
              <nuxt-img
                width="15"
                height="16"
                src="/nuxt-images/solutions/ai/icons/eyebrow-one.svg"
                alt=""
              />
              <div>
                <span>{{ pill.text }}</span
                ><span class="pill-link">{{ pill.link }}</span>
              </div>
              <SlpIcon name="arrow-right" size="sm" variant="product" />
            </a>
          </div>
          <a
            v-if="banner.show === true"
            :href="banner.href"
            class="banner"
            :data-ga-name="banner.data_ga_name"
            :data-ga-location="banner.data_ga_location"
          >
            <img src="/nuxt-images/banner/banner-spark.svg" alt="Spark icon" />
            <SlpTypography variant="body2">{{ banner.text }}</SlpTypography>
            <SlpIcon variant="product" name="arrow-right" />
          </a>
          <img
            src="/nuxt-images/solutions/ai/duo-logo.svg"
            class="slp-mb-24 logo-image"
            rel="preload"
            alt=""
          />
          <div class="animation-wrapper">
            <SlpTypography
              v-if="header"
              variant="heading1-bold"
              tag="h1"
              class="slp-mb-24 animated"
              >{{ header }}</SlpTypography
            >
          </div>
          <div class="animation-wrapper">
            <SlpTypography variant="heading5" tag="h2" class="animated">{{
              description
            }}</SlpTypography>
          </div>
          <div class="animation-wrapper hero-container__buttons">
            <SlpButton
              :href="button.href"
              :variant="button.variant"
              class="animated animated--delayed slp-mt-24"
              :data-ga-name="button.dataGaName"
              :data-ga-location="button.dataGaLocation"
              >{{ button.text }}
              <SlpIcon v-if="button.icon" v-bind="button.icon" class="slp-ml-8"
            /></SlpButton>
            <SlpButton
              v-if="secondaryButton"
              :href="secondaryButton.href"
              :variant="secondaryButton.variant"
              class="animated secondary-button slp-mt-24"
              :data-ga-name="secondaryButton.dataGaName"
              :data-ga-location="secondaryButton.dataGaLocation"
              >{{ secondaryButton.text }}
              <SlpIcon
                v-if="secondaryButton.icon"
                v-bind="secondaryButton.icon"
                class="slp-ml-8"
            /></SlpButton>
          </div>
        </div>
        <div v-if="!video" class="hero-image">
          <HeaderLogo :src="image.src" :alt="image.alt" />
        </div>
        <div v-else>
          <div class="wrapper" @click="openModal()">
            <SlpIcon
              class="play-icon"
              name="play-circle"
              variant="marketing"
              size="xl"
            />
            <img
              id="video-container__image"
              class="thumbnail-image"
              :src="image.src"
              :alt="image.alt"
            />
          </div>

          <VideoModal
            v-show="showModal && video?.video_url"
            light-background
            :visible="showModal"
            @close="showModal = false"
          >
            <template #body>
              <lite-vimeo
                :videoid="getVimeoVideoId(createVideoSource(video?.video_url))"
                autoplay
              ></lite-vimeo>
            </template>
          </VideoModal>
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  padding: 80px 0 128px 0;
  position: relative;
  z-index: 1;

  .hero-container__buttons {
    :deep .slp-btn {
      @media (max-width: $breakpoint-sm) {
        width: 100%;
        justify-content: center;
      }
    }
  }
}

.wrapper {
  position: relative;
  cursor: pointer;

  &::before {
    z-index: 10;

    background: $color-surface-600; /* Updated background gradient */
    border: 1px solid transparent;
    border-radius: 4px 4px 90px 4px;
    bottom: 0;
    content: '';
    left: 0;
    -webkit-mask:
      linear-gradient(#fff, #fff 0) padding-box,
      linear-gradient(#fff, #fff 0);
    -webkit-mask:
      linear-gradient(#fff 0 0) padding-box,
      linear-gradient(#fff 0 0);
    -webkit-mask-composite: xor;
    mask-composite: exclude;
    position: absolute;
    right: 0;
    top: 0;
  }

  .play-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    font-size: 48px;
    color: #fff;
    cursor: pointer;
    z-index: 2;

    ::v-deep path {
      fill: black;
      transition: fill 0.2s ease;
    }

    ::v-deep circle {
      transition: fill 0.2s ease;
    }
  }

  &:hover {
    .thumbnail-image {
      filter: brightness(0.8);
    }

    .play-icon::v-deep {
      circle {
        fill: #171321;
      }
      path {
        fill: white;
      }
    }
  }

  .thumbnail-image {
    position: relative;
    display: block;
    cursor: pointer;
    width: 100%;
    height: 100%;
    object-fit: cover;
    object-position: center;
    border-radius: 4px 4px 90px 4px;
    transition: all 0.2s ease;
  }
}

.hero-wrapper {
  display: flex;
  flex-direction: column;
  align-items: center;
  gap: 32px;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    align-items: center;
  }
  @media (min-width: $breakpoint-lg) {
    gap: 4%;
  }

  .hero-text {
    color: $color-text-50;
    @media (min-width: $breakpoint-md) {
      padding-top: 0;
    }
    .animation-wrapper {
      overflow-y: clip;
      .animated {
        animation-name: intro-reveal;
        animation-fill-mode: forwards;
        animation-delay: 1.6s;
        animation-duration: 0.9s;
        transform: translate3d(0, 150%, 0);
        will-change: transform;
        @media (prefers-reduced-motion) {
          animation: none;
          transform: none !important;
        }
        &--delayed {
          animation-delay: 1.8s;
        }
      }
    }
    .note {
      background: linear-gradient(
        91.08deg,
        #fca326 -9.03%,
        #a686f2 27.88%,
        #a989f5 65.98%
      );
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
    }
  }
}

.hero-pill {
  margin-bottom: 16px;
  position: relative;
  padding: 4px 12px;
  display: inline-block;
  font-weight: 600;
  width: 100%;
  border-radius: 28px;
  cursor: pointer;
  opacity: 0;
  animation: opacity-intro 0.9s linear forwards 1.2s;

  &:before {
    content: '';
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    border-radius: 20px;
    border: 1.5px solid transparent;
    background: linear-gradient(
        89.09deg,
        #e1986d -1.12%,
        #7759c2 102.06%,
        #6e43d3 102.07%
      )
      border-box;
    -webkit-mask:
      linear-gradient(#fff 0, #fff 0) padding-box,
      linear-gradient(#fff 0, #fff 0);
    -webkit-mask:
      linear-gradient(#fff 0 0) padding-box,
      linear-gradient(#fff 0 0);
    -webkit-mask-composite: xor;
    mask-composite: exclude;
  }

  &:hover {
    .slp-icon {
      transform: translateX(8px);
    }
  }

  .slp-icon {
    transition: transform 0.2s ease-in-out;
    margin-bottom: 3px;
    transform: translateX(4px);
  }

  a {
    display: flex;
    color: white;
    align-content: center;
    position: relative;
    align-items: center;
    z-index: 1;
    @media (max-width: $breakpoint-lg) {
      img {
        margin-right: $spacing-4;
      }
    }
  }
  span {
    margin: 0 4px;
    @media (max-width: $breakpoint-md) {
      margin: 0 4px 0 0;
    }
  }
  .pill-link {
    font-weight: 400;
  }
}
.hero-image {
  opacity: 0;
  animation: opacity-intro 0.9s linear forwards 1.6s;
}
.logo-image {
  opacity: 0;
  animation: opacity-intro 0.9s linear forwards 1.2s;
}
.logo-image {
  @media (max-width: $breakpoint-lg) {
    max-width: 100%;
  }
}

.banner {
  display: inline-flex;
  padding: 4px 16px;
  align-items: center;
  gap: 10px;
  color: $color-text-300;
  animation: opacity-intro 0.9s linear forwards 0.8s;
  border-radius: 20px;
  background: var(--slp-color-surface-900, #eee7fd);
  margin-bottom: 36px;
  opacity: 0;
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 150%, 0);
  }
  to {
    transform: translate3d(0, 0%, 0);
  }
}

@keyframes opacity-intro {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
</style>
